(in-package #:cl-user)

(defpackage #:cl-canvas
  (:nicknames #:clc)
  (:use #:cl)
  (:export 
   
   ;; create a new canvas and show it
   #:show-canvas

   ;; a simple drawing program
   #:drawing-program

   ;; unchecked framebuffer access
   #:framebuffer
   #:framebuffer-point

   ;; canvas information
   #:*width*
   #:*height*
   #:*current-color*

   ;; repaints offscreen buffer to canvas
   #:repaint

   ;; clipped access
   #:set-pixel
   #:get-pixel
   #:fill-rect
   #:draw-line
   #:clear-framebuffer
   
   ;; set current drawing color
   #:set-color

   ;; vector font
   #:test-hershey-font
   #:hershey-draw-string
   #:hershey-draw-letter

   ;; Logo-like interface
   #:*current-x*
   #:*current-y*
   #:*current-angle*
   #:*pen-down*
   #:rotate
   #:right
   #:left
   #:pendown
   #:penup
   #:forward

   ;; samples, try (snow 4 140) and (mandelbrot 0.2 0.5 0.4 0.7)
   #:kochcurve
   #:snow
   #:mandelbrot

   ;; testing
   #:test

   ;; key codes
   #:VK_BACK
   #:VK_TAB
   #:VK_CLEAR
   #:VK_RETURN
   #:VK_SHIFT
   #:VK_CONTROL
   #:VK_MENU
   #:VK_PAUSE
   #:VK_CAPITAL
   #:VK_ESCAPE
   #:VK_CONVERT
   #:VK_NONCONVERT
   #:VK_ACCEPT
   #:VK_MODECHANGE
   #:VK_SPACE
   #:VK_PRIOR
   #:VK_NEXT
   #:VK_END
   #:VK_HOME
   #:VK_LEFT
   #:VK_UP
   #:VK_RIGHT
   #:VK_DOWN
   #:VK_SELECT
   #:VK_PRINT
   #:VK_EXECUTE
   #:VK_SNAPSHOT
   #:VK_INSERT
   #:VK_DELETE
   #:VK_HELP
   #:VK_0
   #:VK_1
   #:VK_2
   #:VK_3
   #:VK_4
   #:VK_5
   #:VK_6
   #:VK_7
   #:VK_8
   #:VK_9
   #:VK_A
   #:VK_B
   #:VK_C
   #:VK_D
   #:VK_E
   #:VK_F
   #:VK_G
   #:VK_H
   #:VK_I
   #:VK_J
   #:VK_K
   #:VK_L
   #:VK_M
   #:VK_N
   #:VK_O
   #:VK_P
   #:VK_Q
   #:VK_R
   #:VK_S
   #:VK_T
   #:VK_U
   #:VK_V
   #:VK_W
   #:VK_X
   #:VK_Y
   #:VK_Z
   #:VK_SLEEP
   #:VK_NUMPAD0
   #:VK_NUMPAD1
   #:VK_NUMPAD2
   #:VK_NUMPAD3
   #:VK_NUMPAD4
   #:VK_NUMPAD5
   #:VK_NUMPAD6
   #:VK_NUMPAD7
   #:VK_NUMPAD8
   #:VK_NUMPAD9
   #:VK_MULTIPLY
   #:VK_ADD
   #:VK_SEPARATOR
   #:VK_SUBTRACT
   #:VK_DECIMAL
   #:VK_DIVIDE
   #:VK_F1
   #:VK_F2
   #:VK_F3
   #:VK_F4
   #:VK_F5
   #:VK_F6
   #:VK_F7
   #:VK_F8
   #:VK_F9
   #:VK_F10
   #:VK_F11
   #:VK_F12
   #:VK_F13
   #:VK_F14
   #:VK_F15
   #:VK_F16
   #:VK_F17
   #:VK_F18
   #:VK_F19
   #:VK_F20
   #:VK_F21
   #:VK_F22
   #:VK_F23
   #:VK_F24
   #:VK_NUMLOCK
   #:VK_SCROLL
   ))
